# TODO:
# - package vendored modules

%define		fzfrev		d01ae55
%define		fzfvimrev	9ceac71
%define		fzfgitrev	9190e1b
%define		vendor_version	0.34.0

Summary:	A command-line fuzzy finder written in Go
Name:		fzf
Version:	0.35.1
Release:	2
License:	MIT
Group:		Applications/Shells
#Source0Download: https://github.com/junegunn/fzf/releases
Source0:	https://github.com/junegunn/fzf/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	f8abbd5cf0a203516e39522a90bd4359
# cd fzf-%{version}
# go mod vendor
# cd ..
# tar cJf fzf-vendor-%{version}.tar.xz fzf-%{version}/vendor
Source1:	%{name}-vendor-%{vendor_version}.tar.xz
# Source1-md5:	cd1672b3da7985ddc0709862274a007f
Source2:	https://github.com/junegunn/fzf.vim/archive/%{fzfvimrev}/fzf.vim-%{fzfvimrev}.tar.gz
# Source2-md5:	cf33165a5e500c85838fa994683b2e5d
Source3:	https://github.com/junegunn/fzf-git.sh/archive/%{fzfgitrev}/fzf-git.sh-%{fzfgitrev}.tar.gz
# Source3-md5:	66a5b104f7e6f67c0b4f8556f1a22583
Patch0:		install.patch
URL:		https://github.com/junegunn/fzf
BuildRequires:	golang >= 1.17
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.009
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
ExclusiveArch:	%go_arches
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_debugsource_packages	0

%description
fzf is a general-purpose command-line fuzzy finder.

It's an interactive Unix filter for command-line that can be used with
any list; files, command history, processes, hostnames, bookmarks, git
commits, etc.

%package tmux
Summary:	Script for starting fzf in tmux pane
Requires:	%{name} = %{version}-%{release}
Requires:	coreutils
Requires:	tmux
BuildArch:	noarch

%description tmux
Script for starting fzf in tmux pane.

%package -n bash-completion-fzf
Summary:	bash-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion >= 1:2.0
BuildArch:	noarch

%description -n bash-completion-fzf
bash-completion for fzf.

%package -n zsh-completion-fzf
Summary:	zsh-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	zsh
BuildArch:	noarch

%description -n zsh-completion-fzf
zsh-completion for fzf.

%package git-sh
Summary:	bash and zsh key bindings for Git objects, powered by fzf
Group:		Applications/Shells
Requires:	%{name}-tmux
Requires:	awk
Requires:	coreutils
Requires:	git-core
Requires:	grep
Requires:	sed
Suggests:	xdg-utils
BuildArch:	noarch

%description git-sh
bash and zsh key bindings for Git objects, powered by fzf.

%package -n vim-plugin-fzf
Summary:	fzf integration for Vim
Group:		Applications/Editors/Vim
Requires:	%{name} >= 0.23.0
Requires:	file
Requires:	vim-rt
Suggests:	highlight
Suggests:	ripgrep
Suggests:	the_silver_searcher
BuildArch:	noarch

%description -n vim-plugin-fzf
fzf integration for Vim.

%package -n vim-plugin-fzf-doc
Summary:	Documentation for fzf Vim plugin
Group:		Applications/Editors/Vim
Requires:	vim-plugin-fzf = %{version}-%{release}
Requires:	vim-rt
BuildArch:	noarch

%description -n vim-plugin-fzf-doc
Documentation for fzf Vim plugin.

%prep
%setup -q -a1 -a2 -a3
%{__mv} fzf-%{vendor_version}/vendor .
%{__mv} fzf.vim-%{fzfvimrev}* fzf.vim
%{__mv} fzf-git.sh-%{fzfgitrev}* fzf-git
%patch0 -p1
%{__sed} -i -e "s@let s:bin_dir = .*@let s:bin_dir = '%{_datadir}/fzf/vim/bin/'@" fzf.vim/autoload/fzf/vim.vim
%{__sed} -i -e '1s,.*env bash,#!/bin/bash,' fzf.vim/bin/preview.sh bin/fzf-tmux install
%{__sed} -i -e '1s,.*env perl,#!%{__perl},' fzf.vim/bin/tags.pl

%{__mkdir_p} .go-cache

%build
%__go build -v -mod=vendor -ldflags='-X main.version=%{version} -X main.revision=%{fzfrev}' -o target/fzf

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/fzf/vim/bin,%{_mandir}/man1,%{bash_compdir},%{zsh_compdir}}
install -d $RPM_BUILD_ROOT%{_datadir}/vim/{doc,autoload,plugin/fzf}

install -p target/fzf $RPM_BUILD_ROOT%{_bindir}/fzf
install -p install $RPM_BUILD_ROOT%{_bindir}/fzf-install
install -p bin/fzf-tmux $RPM_BUILD_ROOT%{_bindir}/fzf-tmux
cp -p man/man1/fzf.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p shell/completion.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/completion.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p fzf-git/fzf-git.sh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -rp fzf.vim/autoload/fzf $RPM_BUILD_ROOT%{_datadir}/vim/autoload
cp -p plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf.vim
cp -p fzf.vim/plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf/fzf.vim
cp -p fzf.vim/doc/fzf-vim.txt $RPM_BUILD_ROOT%{_datadir}/vim/doc/fzf.txt
cp -p fzf.vim/bin/{preview.sh,tags.pl} $RPM_BUILD_ROOT%{_datadir}/fzf/vim/bin

%clean
rm -rf $RPM_BUILD_ROOT

%post
%banner -o -e %{name} <<EOF
==> Caveats
To install useful keybindings and fuzzy completion:
  fzf-install
EOF

%post -n vim-plugin-fzf-doc
%vim_doc_helptags

%postun -n vim-plugin-fzf-doc
%vim_doc_helptags

%files
%defattr(644,root,root,755)
%doc BUILD.md CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/fzf
%attr(755,root,root) %{_bindir}/fzf-install
%dir %{_datadir}/fzf
%{_mandir}/man1/fzf.1*

%files tmux
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fzf-tmux

%files -n bash-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.bash
%{_datadir}/fzf/key-bindings.bash

%files -n zsh-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.zsh
%{_datadir}/fzf/key-bindings.zsh

%files git-sh
%defattr(644,root,root,755)
%doc fzf-git/README.md
%{_datadir}/fzf/fzf-git.sh

%files -n vim-plugin-fzf
%defattr(644,root,root,755)
%doc README-VIM.md fzf.vim/README.md
%dir %{_datadir}/fzf/vim
%dir %{_datadir}/fzf/vim/bin
%attr(755,root,root) %{_datadir}/fzf/vim/bin/preview.sh
%attr(755,root,root) %{_datadir}/fzf/vim/bin/tags.pl
%{_datadir}/vim/autoload/fzf
%{_datadir}/vim/plugin/fzf.vim
%{_datadir}/vim/plugin/fzf

%files -n vim-plugin-fzf-doc
%defattr(644,root,root,755)
%{_datadir}/vim/doc/fzf.txt
%changelog
* Tue Dec 20 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fzf.git;a=log;h=master

* Tue Dec 20 2022 Jan Rękorajski <baggins@pld-linux.org> ef0f890
- Release 2 (by relup.sh)

* Fri Nov 18 2022 Jan Palus <atler@pld-linux.org> 0caddac
- up to 0.35.1

* Sat Nov 12 2022 Jan Palus <atler@pld-linux.org> ef6f4d7
- up to 0.35.0

* Fri Sep 30 2022 Jan Palus <atler@pld-linux.org> 45c96c4
- sync fzf-git.sh with upstream and drop awk patch

* Fri Sep 30 2022 Elan Ruusamäe <glen@pld-linux.org> 3c9b463
- Add note about hardcoded paths

* Fri Sep 30 2022 Elan Ruusamäe <glen@pld-linux.org> 2569194
- Fix path to key-bindings file in install script

* Fri Sep 30 2022 Elan Ruusamäe <glen@pld-linux.org> 60c4a75
- Add banner to hint fzf-install setup script

* Fri Sep 30 2022 Elan Ruusamäe <glen@pld-linux.org> f3dfd4e
- Package install script to setup user bashrc/zshrc

* Fri Sep 30 2022 Elan Ruusamäe <glen@pld-linux.org> a6efc4b
- Use install -p to install binaries

* Thu Sep 29 2022 Jan Palus <atler@pld-linux.org> 6d69ec0
- package fzf-git.sh as a part of fzf

* Thu Sep 29 2022 Jan Palus <atler@pld-linux.org> 18596e3
- package fzf-tmux

* Wed Sep 28 2022 Jan Palus <atler@pld-linux.org> 180ed27
- up to 0.34.0

* Mon Aug 29 2022 Jan Palus <atler@pld-linux.org> 7b5365c
- up to 0.33.0

* Mon Aug 08 2022 Jan Palus <atler@pld-linux.org> ef38ca3
- up to 0.32.1

* Tue Aug 02 2022 Jan Palus <atler@pld-linux.org> c3c532e
- up to 0.32.0

* Thu Jul 21 2022 Jan Palus <atler@pld-linux.org> c67783b
- correct bash-completion epoch

* Thu Jul 21 2022 Jan Palus <atler@pld-linux.org> b19a347
- up to 0.31.0

* Mon Apr 04 2022 Jan Palus <atler@pld-linux.org> 7c22ad0
- use go macros

* Mon Apr 04 2022 Jan Palus <atler@pld-linux.org> 7eaa512
- up to 0.30.0

* Sat Dec 25 2021 Jan Palus <atler@pld-linux.org> 697411e
- rpm version for noarch subpackage

